unit dcdemoform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls, ComCtrls,
  FILECTRL, DCLUBLIB;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label5: TLabel;
    LblSystemDT: TLabel;
    Label2: TLabel;
    BtnCalcAge: TButton;
    EdYear: TEdit;
    EdMonth: TEdit;
    EdDay: TEdit;
    SGDates: TStringGrid;
    BtnChangeTime: TButton;
    BtnChangeDate: TButton;
    PanDateSet: TPanel;
    Label3: TLabel;
    EdSysYear: TEdit;
    EdSysDay: TEdit;
    EdSysMonth: TEdit;
    PanTimeSet: TPanel;
    Label4: TLabel;
    EdSysHour: TEdit;
    EdSysMin: TEdit;
    EdSysSec: TEdit;
    TSString: TTabSheet;
    LblSysDateTimeReal: TLabel;
    Label6: TLabel;
    EdString: TEdit;
    LblLeft: TLabel;
    EdLeft: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    EdRight: TEdit;
    Label10: TLabel;
    EdRep: TEdit;
    LblRight: TLabel;
    lblRep: TLabel;
    Timer1: TTimer;
    Label7: TLabel;
    Label11: TLabel;
    EdPadL: TEdit;
    EdPadR: TEdit;
    BtnShowStr: TButton;
    LblPadL: TLabel;
    LblPadR: TLabel;
    EdPadLChar: TEdit;
    EdPadRChar: TEdit;
    EdRepStr: TEdit;
    TSFile: TTabSheet;
    LblExeName: TLabel;
    LblAppDir: TLabel;
    LblDateTime: TLabel;
    LblCopy: TLabel;
    CBCopyOVR: TCheckBox;
    BtnFileCopy: TButton;
    LblCopyResult: TLabel;
    Bevel1: TBevel;
    Panel1: TPanel;
    LBParse: TListBox;
    LblParseString: TLabel;
    BtnParse: TButton;
    LblFirst: TLabel;
    LblLast: TLabel;
    Label13: TLabel;
    LblMove: TLabel;
    BtnMove: TButton;
    CBMoveOVR: TCheckBox;
    LblMoveResult: TLabel;
    Bevel3: TBevel;
    procedure BtnCalcAgeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BtnChangeTimeClick(Sender: TObject);
    procedure BtnChangeDateClick(Sender: TObject);
    procedure EdStringChange(Sender: TObject);
    procedure BtnShowStrClick(Sender: TObject);
    procedure BtnFileCopyClick(Sender: TObject);
    procedure BtnParseClick(Sender: TObject);
    procedure BtnMoveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BtnCalcAgeClick(Sender: TObject);
var
  BirthDate: TDate;
  WinDateFormat: string;
begin
  if not IsEmptyStr(EdYear.Text) and
     (Length(EdYear.Text) < 4) then begin
    MessageDlg('You must be joking...', mtConfirmation, [mbOK], 0);
    exit;
  end;

  try
    BirthDate := EncodeDate(StrToInt(EdYear.Text),
      StrToInt(EdMonth.Text), StrToInt(EdDay.Text));
    if not SGDates.Visible then SGDates.Visible := TRUE;
    SGDates.Cells[0,0] := 'Age';
    SGDates.Cells[1,0] := IntToStr(Age(BirthDate));
    SGDates.Cells[0,1] := 'Birthday:';
    SGDates.Cells[0,2] := 'Actual Windows setting';
    SGDates.Cells[1,2] := DateToStr(BirthDay(BirthDate));
    WinDateFormat := ShortDateFormat;
    ShortDateFormat := 'mm/dd/yyyy';
    SGDates.Cells[0,3] := 'US format';
    SGDates.Cells[1,3] := DateToStr(BirthDay(BirthDate));
    ShortDateFormat := 'dd/mm/yyyy';
    SGDates.Cells[0,4] := 'European format';
    SGDates.Cells[1,4] := DateToStr(BirthDay(BirthDate));
    ShortDateFormat := WinDateFormat;
    SGDates.Cells[0,5] := 'ISO format';
    SGDates.Cells[1,5] := DateToISO(BirthDay(BirthDate));
    SGDates.Cells[0,6] := 'ISO short format';
    SGDates.Cells[1,6] := DateToISOShort(BirthDay(BirthDate));
    SGDates.Cells[0,7] := 'As Real number';
    SGDates.Cells[1,7] := Format('%11.5f', [BirthDay(BirthDate)]);
   except
     MessageDlg('Invalid date.', mtWarning, [mbOK], 0);
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LblSystemDT.Caption := DateTimeToStr(Now);
  LblSysDateTimeReal.Caption := Format('%11.5f', [Real(Now)]);
  SGDates.Visible := FALSE;
  PanDateSet.Visible := FALSE;
  PanTimeSet.Visible := FALSE;
  LblExeName.Caption := 'Application: ' + Application.ExeName;
  LblDateTime.Caption := 'Created/Modified: ' + FileDateTimeStr(Application.ExeName);
  LblAppDir.Caption := 'App. directory: ' + AppDir;
  LblCopy.Caption := 'Copy exe-file to ' + AppDir + '\' + 'test.xyz';
  LblMove.Caption := '...';
  BtnMove.Enabled := FALSE;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  LblSystemDT.Caption := DateTimeToStr(Now);
  LblSysDateTimeReal.Caption := Format('%11.5f', [Real(Now)]);
end;

procedure TForm1.BtnChangeTimeClick(Sender: TObject);
var
  NewTime: TTime;
begin
  if not PanTimeSet.Visible then begin
    BtnChangeTime.Caption := 'Set the new time';
    PanTimeSet.Visible := TRUE;
    EdSysHour.SetFocus;
  end
  else
    try
      NewTime := EncodeTime(StrToInt(EdSysHour.Text),
        StrToInt(EdSysMin.Text), StrToInt(EdSysSec.Text), 0);
      SetSysTime(NewTime);
      BtnChangeTime.Caption := 'Change System Time';
      PanTimeSet.Visible := FALSE;
    except
      MessageDlg('Invalid time.', mtWarning, [mbOK], 0);
    end;
end;

procedure TForm1.BtnChangeDateClick(Sender: TObject);
var
  NewDate: TDate;
begin
  if not PanDateSet.Visible then begin
    PanDateSet.Visible := TRUE;
    BtnChangeDate.Caption := 'Set the new date';
    EdSysYear.SetFocus;
  end
  else
    try
      NewDate := EncodeDate(StrToInt(EdSysYear.Text),
        StrToInt(EdSysMonth.Text), StrToInt(EdSysDay.Text));
      SetSysDate(NewDate);
      BtnChangeDate.Caption := 'Change System Date';
      PanDateSet.Visible := FALSE;
    except
      MessageDlg('Invalid date.', mtWarning, [mbOK], 0);
    end;
end;

procedure TForm1.EdStringChange(Sender: TObject);
begin
  BtnShowStr.Click;
end;

procedure TForm1.BtnShowStrClick(Sender: TObject);
var
  L, R, Rep, PadL, PadR, Code: integer;
begin
  val(EdLeft.Text, L, Code);
  if Code > 0 then ShowMessage('Invalid value of LEFT.')
  else LblLeft.Caption := LeftStr(EdString.Text, L);

  val(EdRight.Text, R, Code);
  if Code > 0 then ShowMessage('Invalid value of RIGHT.')
  else LblRight.Caption := RightStr(EdString.Text, R);

  val(EdRep.Text, Rep, Code);
  if Code > 0 then ShowMessage('Invalid value of REPLICATE.')
  else LblRep.Caption := RepliStr(EdRepStr.Text, Rep);

  val(EdPadL.Text, PadL, Code);
  if Code > 0 then ShowMessage('Invalid value of PAD LEFT.')
  else LblPadL.Caption := PadLeft(EdString.Text, PadL, EdPadLChar.Text[1]);

  val(EdPadR.Text, PadR, Code);
  if Code > 0 then ShowMessage('Invalid value of PAD RIGHT.')
  else LblPadR.Caption := PadRight(EdString.Text, PadR, EdPadRChar.Text[1]);
end;

procedure TForm1.BtnFileCopyClick(Sender: TObject);
var
  FromFile, ToFile: string;
begin
  FromFile := Application.ExeName;
  ToFile := ParseGetLast(LblCopy.Caption, ' ');
  if FileCopy(FromFile, ToFile, CBCopyOVR.Checked) then begin
    LblCopyResult.Caption := 'The file was copied.';
    BtnMove.Enabled := TRUE;
    LblMove.Caption := 'Move ' + ToFile + ' to ' +
      AppDir + '\move\data\' + ExtractFileName(ToFile);
  end
  else
    LblCopyResult.Caption := 'The file was NOT copied.'
end;

procedure TForm1.BtnParseClick(Sender: TObject);
const
  Delimiters = ' ():,.';
var
  SL: TStringList;
begin
  LblFirst.Caption := 'The first word is: ' +
    ParseGetFirst(LblParseString.Caption, Delimiters);
  LblLast.Caption := 'The last word is: ' +
    ParseGetLast(LblParseString.Caption, Delimiters);
  SL := ParseToList(LblParseString.Caption, Delimiters);
  LBParse.Items.Assign(SL);
  SL.Free;
end;

procedure TForm1.BtnMoveClick(Sender: TObject);
var
  FromFile, ToFile, Direct: string;
  MoveResult: TMoveResult;
begin
  FromFile := ParseGetLast(LblCopy.Caption, ' ');
  ToFile := ParseGetLast(LblMove.Caption, ' ');
  MoveResult := FileMove(FromFile, ToFile, CBMoveOVR.Checked);
  case MoveResult of
    fmovOK: LblMoveResult.Caption := 'The file was moved.';
    fmovNOTDELETED: LblMoveResult.Caption := 'The file was copied, but the ' +
      'original could not be deleted.';
    fmovFAIL: LblMoveResult.Caption := 'The file was NOT moved.';
  end;
end;

end.
